<?php
    use PFBC\Form;
    use PFBC\Element;
    use PFBC\View;
    use PFBC\Validation;
    use documongo\MongoObject\Document;
    use documongo\MongoObject\DocumentType;
    require_once('lib/frole.php');
    $role = new Role();
    $role->isPageEnable($user->uuid);

require_once("lib/fconnect.php");
$db = DBConnect::getInstance();


    function getPDFlist($roles, $db, $user){
        //var_dump($roles);
        $mainrole = $out = '';
        foreach($roles as $one){
            if($one == 'dean' && $mainrole !== 'prorector'){$mainrole = 'dean';}
            if($one == 'prorector'){$mainrole = 'prorector';}
            if($one == 'admin'){$mainrole = 'admin'; break;}
            if($one == 'moderator'){$mainrole = 'moderator'; break;}
            if($one == 'customer'){$mainrole = 'customer'; break;}

        }

        $linksTable = array();
        $formTypes = array("институт", "факультет", "филиал");

        switch ($mainrole) {
            case 'dean':
                $objects = array();
                $rules = $db->colRules->find(array('actors'=>$user->uuid));
                foreach($rules as $rule){
                    foreach($rule['objects'] as $object){
                        if(strlen($object)==36){
                            $objects[]=$object;
                        }
                    }
                }
                $objects = array_unique($objects);
                foreach($objects as $object){
                    $doc = $db->colDocs->findOne(array('uuid'=>$object,'type'=>'faculty'));

                    if (is_null($doc)) {
                        continue;
                    }

                    $linkHtml = '';
                    $filename = 'pdf/'.md5($doc['title_ru']).'.pdf';
                    if(file_exists($filename)){
                        $linkHtml .= '<li><a target="_blank" href="'.$filename.'?'.time().'">'.$doc['title_ru'].'</a></li>';
                    }else{
                        // $linkHtml .= '<li><a class="muted">'.$doc['title_ru'].' (не загружено)</a></li>';
                    }

                    $docFormType = '';
                    foreach ($formTypes as $formType) {
                        if (mb_stripos($doc["title_ru"], $formType) !== false) {
                            $docFormType = $formType;
                            break;
                        }
                    }
                    if (!isset($linksTable[$doc['prorector']])) {
                        $linksTable[$doc['prorector']] = array_fill_keys($formTypes, array());
                    }
                    $sortTitle = trim(str_replace(mb_strtolower($docFormType), "", mb_strtolower($doc["title_ru"])));
                    $linksTable[$doc['prorector']][$docFormType][$sortTitle] = $linkHtml;
                }
                break;

            case 'prorector':
            case 'customer':
                $what = array('type'=>'faculty');
                $documents = $db->colDocs->find($what);
                foreach($documents as $doc){
                        $linkHtml = '';
                        $filename = 'pdf/'.md5($doc['title_ru']).'.pdf';
                        if(file_exists($filename)){
                            $linkHtml .= '<li><a target="_blank" href="'.$filename.'?'.time().'">'.$doc['title_ru'].'</li>';
                        }else{
                            // $linkHtml .= '<li><a class="muted">'.$doc['title_ru'].' (не загружено)</a></li>';
                        }

                        $docFormType = '';
                        foreach ($formTypes as $formType) {
                            if (mb_stripos($doc["title_ru"], $formType) !== false) {
                                $docFormType = $formType;
                                break;
                            }
                        }
                        if (!isset($linksTable[$doc['prorector']])) {
                            $linksTable[$doc['prorector']] = array_fill_keys($formTypes, array());
                        }
                        $sortTitle = trim(str_replace(mb_strtolower($docFormType), "", mb_strtolower($doc["title_ru"])));
                        $linksTable[$doc['prorector']][$docFormType][$sortTitle] = $linkHtml;
                }
                break;

            case 'moderator':
            case 'admin':

                $what = array('type'=>'faculty');
                $documents = $db->colDocs->find($what);
                $documents->sort(array("prorector" => -1));
                foreach($documents as $doc){
                        $linkHtml = '';
                        $filename = 'pdf/'.md5($doc['title_ru']).'.pdf';
                        if(file_exists($filename)){
                            $linkHtml .= '<li style="background: #efefef; margin-bottom: 20px; padding: 5px;"><a target="_blank" href="'.$filename.'?'.time().'">'.$doc['title_ru'].'</a>';
                        }else{
                            $linkHtml .= '<li style="background: #efefef; margin-bottom: 20px; padding: 5px;"><a class="muted">'.$doc['title_ru'].' (не загружено)</a>';
                        }
                        $linkHtml .=''
                            . '<form action="upload.php" method="post" target="hiddenframe" enctype="multipart/form-data" onsubmit="hideBtn();" style="display: inline-block;" >
                                  <input type="file" id="userfile" style="display: block;" name="userfile" style="margin-left: 10px;"/>
                                  <input type="hidden" name="filename1" id="filename1" value="'.md5($doc['title_ru']).'.pdf">
                                  <input type="submit" name="upload" id="upload'.md5($doc['title_ru']).'" value="Загрузить" class="btn btn-primary" />
                                </form>'
                            . '<form action="upload.php" method="post" target="hiddenframe" enctype="multipart/form-data" onsubmit="hideBtn();" style="display: inline-block;float: right;top: -47px;position: relative;right: 100px">
                                  <input type="hidden" name="filename1" id="filename1" value="'.md5($doc['title_ru']).'.pdf">
                                  <input type="submit" name="delete-upload" id="upload'.md5($doc['title_ru']).'" value="Удалить файл" class="btn btn-link btn-small" />
                                </form>'
                            . '<div style="clear: both;"></div>'
                        . '</li>';

                        $docFormType = '';
                        foreach ($formTypes as $formType) {
                            if (mb_stripos($doc["title_ru"], $formType) !== false) {
                                $docFormType = $formType;
                                break;
                            }
                        }
                        if (!isset($linksTable[$doc['prorector']])) {
                            $linksTable[$doc['prorector']] = array_fill_keys($formTypes, array());
                        }
                        $sortTitle = trim(str_replace(mb_strtolower($docFormType), "", mb_strtolower($doc["title_ru"])));
                        $linksTable[$doc['prorector']][$docFormType][$sortTitle] = $linkHtml;
                }
                break;
        }

        $out .= implode('', array_map(function($prorectorLinks, $prorector) use ($formTypes) {
                return '<div class="row">'
                    . implode("", array_map(function($formLinks, $form) use ($prorector) {
                            if (empty($formLinks)) {
                                // return '';
                            }
                            ksort($formLinks);
                            return '<div class="span4"><ul class="nav nav-pills nav-stacked" >'
                                . implode("", $formLinks)
                                . '</ul></div>';
                        }, $prorectorLinks, array_keys($prorectorLinks)))
                    . '</div>';
            }, $linksTable, array_keys($linksTable)));
        if($out !== ''){
            $out = ''.$out.'';
        }else{
            $out='<p class="text-error">Нет данных для отображения</p>';
        }
        return $out;
    }

?>
<!doctype html>
<html lang="ru">
<head>
<meta charset="utf-8" />
<title>Отдел ученого секретаря</title>
<link rel="stylesheet" href="/css/jquery-ui.css" />

<script src="/js/jquery-1.9.1.js"></script>
<script src="/js/jquery-ui.js"></script>
<script src="/js/jquery.form.js"></script>

<link type="text/css" rel="stylesheet" href="/css/bootstrap-combined.min.css">
<script src="/js/bootstrap.min.js"></script>
<link rel="stylesheet" href="/css/base.css?rand=<?=rand();?>" />
<link rel="stylesheet" href="/css/member.css?rand=<?=rand();?>" />
<link rel="stylesheet" href="/css/member.form.css?rand=<?=rand();?>" />
<link rel="stylesheet" href="/css/admin.css" />
<link rel="stylesheet" href="/css/navigation__horizontal.css" />
 <link rel="stylesheet" href="/css/messages.css" />
     <script type="text/javascript">

        function hideBtn(uploadid){
            $('#upload' + uploadid).hide();
            $('#res').html("Идет загрузка файла");
        }

        function handleResponse(mes) {
            $('#upload').show();
            if (mes.errors != null) {
                $('#res').html("Возникли ошибки во время загрузки файла: " + mes.errors);
            }
            else {
                $('#res').html("Файл " + mes.name + " загружен");
            }
        }
    </script>


  <script src="/js/auth.js"></script>
  <script>
    var language = "<?=$language?>";
    var pageType = "<?=$pageType?>";

  </script>
</head>

<body>


<header class="header gradient">
  <div class="header__logo">
    <img src="/images/herzen.png" />
  </div>
  <div class="header__headings">
    <h1 class="header__headings__heading">
      Отдел ученого секретаря
    </h1>
    <h2 class="header__headings__subheading">
      <small class="header__headings__subheading__subsubheading">
        Информационно-аналитические материалы
      </small>
    </h2>
  </div>

  <div class="userbox userbox_parent_header">
    <div class="userbox__controls">
      <span class="userbox__controls__profile">профиль</span> / <span class="userbox__controls__logout">выход</span>
    </div>
    <div class="userbox__username">
        <span class="userbox__username__displayname" data-uuid="<?=$this->user->uuid?>"><?=$this->user->givenname?> <?=$this->user->lastname?></span>
    </div>
  </div>

  <div class="header__helper"></div>
</header>

<div>
    <?php
echo $role->userMenu($user->uuid, $db);
    ?>
</div>


<!-- CURRENT PAGE -->
<div class="container container-center">
<h3>Информационно-аналитические материалы</h3>
<p><em>По данным управления кадров и социальной работы от <!--21 ноября 2016--> 19 мая 2017 года</em></p>
<?=getPDFlist($role->getRoles($user->uuid), $db, $user)?>

<div id="res"></div>
<iframe id="hiddenframe" name="hiddenframe" style="width:0px; height:0px; border:0px"></iframe>

</div>
</body>
</html>
